"""
    Abfallnavi API

    Termine für Leerung des Abfalls nach Abfallart (Papier, Restmüll, ...). Beispielswerte sind für das Rathaus Nürnberg (Hauptmarkt 18, Nürnberg).  # Kommunen / Regionen  Das System ist in diverse Regionen unterteilt. Zu einer `Region` gehören ein oder mehrere Kommunen.  * `aachen`: Aachen * `zew2`: AWA Entsorgungs GmbH * `aw-bgl2`: Bergisch Gladbach * `bav`: Bergischer Abfallwirtschaftverbund * `din`: Dinslaken * `dorsten`: Dorsten * `gt2`: Gütersloh * `hlv`: Halver * `coe`: Kreis Coesfeld * `krhs`: Kreis Heinsberg * `pi`: Kreis Pinneberg * `krwaf`: Kreis Warendorf * `lindlar`: Lindlar * `stl`: Lüdenscheid * `nds`: Norderstedt * `nuernberg`: Nürnberg * `roe`: Roetgen * `solingen`: Solingen * `wml2`: EGW Westmünsterland  # Benutzung  Für die Abfrage von Terminen ist eine Reihe von IDs (von Orten, Straßen und/oder Hausnummern) in Erfahrung zu bringen. Vorsicht:IDs können sich mit der Zeit ändern  1. Orte aus System holen 2. Mit Ort die Straßen abfragen 3. Mit Straße die Hausnummern abfragen 4. Mit Haunummer die möglichen Fraktionen (Müllsorten) abfragen 5. Mit Hausnummer und Fraktionen alle Termine abrufen  Manchmal wird nicht nach Hausnummer unterschieden   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: kontakt@bund.dev
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from deutschland.abfallnavi.api_client import ApiClient
from deutschland.abfallnavi.api_client import Endpoint as _Endpoint
from deutschland.abfallnavi.model.abholung import Abholung
from deutschland.abfallnavi.model.region import Region
from deutschland.abfallnavi.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types,
)


class TermineApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.download_as_file_endpoint = _Endpoint(
            settings={
                "response_type": (str,),
                "auth": [],
                "endpoint_path": "/kalender-{region}/downloadfile.jsp",
                "operation_id": "download_as_file",
                "http_method": "GET",
                "servers": [
                    {
                        "url": "https://abfallkalender.regioit.de",
                        "description": "No description provided",
                    },
                ],
            },
            params_map={
                "all": [
                    "region",
                    "format",
                    "jahr",
                    "ort",
                    "strasse",
                    "hnr",
                    "fraktion",
                ],
                "required": [
                    "region",
                    "format",
                    "jahr",
                    "ort",
                    "strasse",
                    "hnr",
                    "fraktion",
                ],
                "nullable": [],
                "enum": [
                    "format",
                ],
                "validation": [],
            },
            root_map={
                "validations": {},
                "allowed_values": {
                    ("format",): {"PDF": "pdf", "ICS": "ics"},
                },
                "openapi_types": {
                    "region": (Region,),
                    "format": (str,),
                    "jahr": (int,),
                    "ort": (str,),
                    "strasse": (int,),
                    "hnr": (int,),
                    "fraktion": ([int],),
                },
                "attribute_map": {
                    "region": "region",
                    "format": "format",
                    "jahr": "jahr",
                    "ort": "ort",
                    "strasse": "strasse",
                    "hnr": "hnr",
                    "fraktion": "fraktion",
                },
                "location_map": {
                    "region": "path",
                    "format": "query",
                    "jahr": "query",
                    "ort": "query",
                    "strasse": "query",
                    "hnr": "query",
                    "fraktion": "query",
                },
                "collection_format_map": {
                    "fraktion": "multi",
                },
            },
            headers_map={
                "accept": ["application/octet-stream"],
                "content_type": [],
            },
            api_client=api_client,
        )
        self.termine_pro_haussnummer_endpoint = _Endpoint(
            settings={
                "response_type": ([Abholung],),
                "auth": [],
                "endpoint_path": "/hausnummern/{hausnummernId}/termine",
                "operation_id": "termine_pro_haussnummer",
                "http_method": "GET",
                "servers": None,
            },
            params_map={
                "all": [
                    "hausnummern_id",
                    "fraktion",
                ],
                "required": [
                    "hausnummern_id",
                    "fraktion",
                ],
                "nullable": [],
                "enum": [],
                "validation": [],
            },
            root_map={
                "validations": {},
                "allowed_values": {},
                "openapi_types": {
                    "hausnummern_id": (int,),
                    "fraktion": ([int],),
                },
                "attribute_map": {
                    "hausnummern_id": "hausnummernId",
                    "fraktion": "fraktion",
                },
                "location_map": {
                    "hausnummern_id": "path",
                    "fraktion": "query",
                },
                "collection_format_map": {
                    "fraktion": "multi",
                },
            },
            headers_map={
                "accept": ["application/json"],
                "content_type": [],
            },
            api_client=api_client,
        )
        self.termine_pro_strasse_endpoint = _Endpoint(
            settings={
                "response_type": ([Abholung],),
                "auth": [],
                "endpoint_path": "/strassen/{strassenId}/termine",
                "operation_id": "termine_pro_strasse",
                "http_method": "GET",
                "servers": None,
            },
            params_map={
                "all": [
                    "strassen_id",
                    "fraktion",
                ],
                "required": [
                    "strassen_id",
                    "fraktion",
                ],
                "nullable": [],
                "enum": [],
                "validation": [],
            },
            root_map={
                "validations": {},
                "allowed_values": {},
                "openapi_types": {
                    "strassen_id": (int,),
                    "fraktion": ([int],),
                },
                "attribute_map": {
                    "strassen_id": "strassenId",
                    "fraktion": "fraktion",
                },
                "location_map": {
                    "strassen_id": "path",
                    "fraktion": "query",
                },
                "collection_format_map": {
                    "fraktion": "multi",
                },
            },
            headers_map={
                "accept": ["application/json"],
                "content_type": [],
            },
            api_client=api_client,
        )

    def download_as_file(
        self, region, format, jahr, ort, strasse, hnr, fraktion, **kwargs
    ):
        """Datenexport als PDF oder ICS  # noqa: E501

        Datenexport als PDF oder ICS  **Hinweis**: Aus der Webseite heraus kann diese Abfrage nicht ausgeführt werden, weil kein Access-Control-Allow-Origin Header gesetzt wird.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.download_as_file(region, format, jahr, ort, strasse, hnr, fraktion, async_req=True)
        >>> result = thread.get()

        Args:
            region (Region): Region
            format (str): Datenformat
            jahr (int): Jahr
            ort (str): Ortsname
            strasse (int): Id der Straße
            hnr (int): Id der Hausnummer
            fraktion ([int]):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            str
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs["async_req"] = kwargs.get("async_req", False)
        kwargs["_return_http_data_only"] = kwargs.get("_return_http_data_only", True)
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")
        kwargs["_request_auths"] = kwargs.get("_request_auths", None)
        kwargs["region"] = region
        kwargs["format"] = format
        kwargs["jahr"] = jahr
        kwargs["ort"] = ort
        kwargs["strasse"] = strasse
        kwargs["hnr"] = hnr
        kwargs["fraktion"] = fraktion
        return self.download_as_file_endpoint.call_with_http_info(**kwargs)

    def termine_pro_haussnummer(self, hausnummern_id, fraktion, **kwargs):
        """Abholtermine für Hausnummer  # noqa: E501

        Abholtermine für Hausnummer. Siehe id unter Pfad `/strassen/{strassenId}` für die hausnummernId.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.termine_pro_haussnummer(hausnummern_id, fraktion, async_req=True)
        >>> result = thread.get()

        Args:
            hausnummern_id (int): Id der Hausnummer
            fraktion ([int]):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            [Abholung]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs["async_req"] = kwargs.get("async_req", False)
        kwargs["_return_http_data_only"] = kwargs.get("_return_http_data_only", True)
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")
        kwargs["_request_auths"] = kwargs.get("_request_auths", None)
        kwargs["hausnummern_id"] = hausnummern_id
        kwargs["fraktion"] = fraktion
        return self.termine_pro_haussnummer_endpoint.call_with_http_info(**kwargs)

    def termine_pro_strasse(self, strassen_id, fraktion, **kwargs):
        """Abholtermine für Straße  # noqa: E501

        Abholtermine für Straße. Siehe id unter Pfad `/orte/{ortId}/strassen` für die strassenId.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.termine_pro_strasse(strassen_id, fraktion, async_req=True)
        >>> result = thread.get()

        Args:
            strassen_id (int): Id der Strasse
            fraktion ([int]):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            [Abholung]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs["async_req"] = kwargs.get("async_req", False)
        kwargs["_return_http_data_only"] = kwargs.get("_return_http_data_only", True)
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")
        kwargs["_request_auths"] = kwargs.get("_request_auths", None)
        kwargs["strassen_id"] = strassen_id
        kwargs["fraktion"] = fraktion
        return self.termine_pro_strasse_endpoint.call_with_http_info(**kwargs)
