# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['deutschland',
 'deutschland.abfallnavi',
 'deutschland.abfallnavi.api',
 'deutschland.abfallnavi.apis',
 'deutschland.abfallnavi.model',
 'deutschland.abfallnavi.models']

package_data = \
{'': ['*']}

install_requires = \
['python-dateutil', 'urllib3>=1.25.3']

setup_kwargs = {
    'name': 'de-abfallnavi',
    'version': '0.1.0',
    'description': 'Abfallnavi API',
    'long_description': '# abfallnavi\nTermine für Leerung des Abfalls nach Abfallart (Papier, Restmüll, ...). Beispielswerte sind für das Rathaus Nürnberg (Hauptmarkt 18, Nürnberg).\n\n# Kommunen / Regionen\n\nDas System ist in diverse Regionen unterteilt. Zu einer `Region` gehören ein oder mehrere Kommunen.\n\n* `aachen`: Aachen\n* `zew2`: AWA Entsorgungs GmbH\n* `aw-bgl2`: Bergisch Gladbach\n* `bav`: Bergischer Abfallwirtschaftverbund\n* `din`: Dinslaken\n* `dorsten`: Dorsten\n* `gt2`: Gütersloh\n* `hlv`: Halver\n* `coe`: Kreis Coesfeld\n* `krhs`: Kreis Heinsberg\n* `pi`: Kreis Pinneberg\n* `krwaf`: Kreis Warendorf\n* `lindlar`: Lindlar\n* `stl`: Lüdenscheid\n* `nds`: Norderstedt\n* `nuernberg`: Nürnberg\n* `roe`: Roetgen\n* `solingen`: Solingen\n* `wml2`: EGW Westmünsterland\n\n# Benutzung\n\nFür die Abfrage von Terminen ist eine Reihe von IDs (von Orten, Straßen und/oder Hausnummern) in Erfahrung zu bringen. Vorsicht:IDs können sich mit der Zeit ändern\n\n1. Orte aus System holen\n2. Mit Ort die Straßen abfragen\n3. Mit Straße die Hausnummern abfragen\n4. Mit Haunummer die möglichen Fraktionen (Müllsorten) abfragen\n5. Mit Hausnummer und Fraktionen alle Termine abrufen\n\nManchmal wird nicht nach Hausnummer unterschieden\n\n\nThis Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:\n\n- API version: 1.0.0\n- Package version: 0.1.0\n- Build package: org.openapitools.codegen.languages.PythonClientCodegen\n\n## Requirements.\n\nPython >= 3.6\n\n## Installation & Usage\n### pip install\n\n```sh\npip install deutschland[abfallnavi]\n```\n\n### poetry install\n\n```sh\npoetry add deutschland -E abfallnavi\n```\n\n### Setuptools\n\nInstall via [Setuptools](http://pypi.python.org/pypi/setuptools).\n\n```sh\npython setup.py install --user\n```\n(or `sudo python setup.py install` to install the package for all users)\n\n## Usage\n\nImport the package:\n```python\nfrom deutschland import abfallnavi\n```\n\n## Getting Started\n\nPlease follow the [installation procedure](#installation--usage) and then run the following:\n\n```python\n\nimport time\nfrom deutschland import abfallnavi\nfrom pprint import pprint\nfrom deutschland.abfallnavi.api import abholpunkte_api\nfrom deutschland.abfallnavi.model.ort import Ort\nfrom deutschland.abfallnavi.model.ort2 import Ort2\nfrom deutschland.abfallnavi.model.strasse import Strasse\n# Defining the host is optional and defaults to https://nuernberg-abfallapp.regioit.de/abfall-app-nuernberg/rest\n# See configuration.py for a list of all supported configuration parameters.\nconfiguration = abfallnavi.Configuration(\n    host = "https://nuernberg-abfallapp.regioit.de/abfall-app-nuernberg/rest"\n)\n\n\n\n# Enter a context with an instance of the API client\nwith abfallnavi.ApiClient(configuration) as api_client:\n    # Create an instance of the API class\n    api_instance = abholpunkte_api.AbholpunkteApi(api_client)\n    strassen_id = 1 # int | Id der Straße\n\n    try:\n        # Hausnummern in Straße\n        api_response = api_instance.hausnummern_pro_strasse(strassen_id)\n        pprint(api_response)\n    except abfallnavi.ApiException as e:\n        print("Exception when calling AbholpunkteApi->hausnummern_pro_strasse: %s\\n" % e)\n```\n\n## Documentation for API Endpoints\n\nAll URIs are relative to *https://nuernberg-abfallapp.regioit.de/abfall-app-nuernberg/rest*\n\nClass | Method | HTTP request | Description\n------------ | ------------- | ------------- | -------------\n*AbholpunkteApi* | [**hausnummern_pro_strasse**](docs/AbholpunkteApi.md#hausnummern_pro_strasse) | **GET** /strassen/{strassenId} | Hausnummern in Straße\n*AbholpunkteApi* | [**ort**](docs/AbholpunkteApi.md#ort) | **GET** /orte/{ortId} | Informationen zu Ort\n*AbholpunkteApi* | [**orte**](docs/AbholpunkteApi.md#orte) | **GET** /orte | Orte im System\n*AbholpunkteApi* | [**strassen_pro_ort**](docs/AbholpunkteApi.md#strassen_pro_ort) | **GET** /orte/{ortId}/strassen | Straßen im Ort\n*FraktionenApi* | [**muellarten**](docs/FraktionenApi.md#muellarten) | **GET** /fraktionen | Müllarten im System\n*FraktionenApi* | [**muellarten_pro_hausnummer**](docs/FraktionenApi.md#muellarten_pro_hausnummer) | **GET** /hausnummern/{hausnummernId}/fraktionen | Müllarten für Hausnummer\n*FraktionenApi* | [**muellarten_pro_strasse**](docs/FraktionenApi.md#muellarten_pro_strasse) | **GET** /strassen/{strassenId}/fraktionen | Müllarten für Straßen\n*TermineApi* | [**download_as_file**](docs/TermineApi.md#download_as_file) | **GET** /kalender-{region}/downloadfile.jsp | Datenexport als PDF oder ICS\n*TermineApi* | [**termine_pro_haussnummer**](docs/TermineApi.md#termine_pro_haussnummer) | **GET** /hausnummern/{hausnummernId}/termine | Abholtermine für Hausnummer\n*TermineApi* | [**termine_pro_strasse**](docs/TermineApi.md#termine_pro_strasse) | **GET** /strassen/{strassenId}/termine | Abholtermine für Straße\n\n\n## Documentation For Models\n\n - [Abholung](docs/Abholung.md)\n - [Bezirk](docs/Bezirk.md)\n - [Fraktion](docs/Fraktion.md)\n - [Hausnummer](docs/Hausnummer.md)\n - [Ort](docs/Ort.md)\n - [Ort2](docs/Ort2.md)\n - [OrtInner](docs/OrtInner.md)\n - [Region](docs/Region.md)\n - [Strasse](docs/Strasse.md)\n\n\n## Documentation For Authorization\n\n All endpoints do not require authorization.\n\n## Author\n\nkontakt@bund.dev\n\n\n## Notes for Large OpenAPI documents\nIf the OpenAPI document is large, imports in abfallnavi.apis and abfallnavi.models may fail with a\nRecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:\n\nSolution 1:\nUse specific imports for apis and models like:\n- `from deutschland.abfallnavi.api.default_api import DefaultApi`\n- `from deutschland.abfallnavi.model.pet import Pet`\n\nSolution 2:\nBefore importing the package, adjust the maximum recursion limit as shown below:\n```\nimport sys\nsys.setrecursionlimit(1500)\nfrom deutschland import abfallnavi\nfrom deutschland.abfallnavi.apis import *\nfrom deutschland.abfallnavi.models import *\n```\n\n',
    'author': 'BundesAPI',
    'author_email': 'kontakt@bund.dev',
    'maintainer': None,
    'maintainer_email': None,
    'url': 'https://github.com/poschi3/abfallnavi-api',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.6',
}


setup(**setup_kwargs)
